<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>ModalType - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="EnumType.html">EnumType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="EnumType.html#getInterpolatedValue">getInterpolatedValue</a></li></ul></li><li><a href="ListType.html">ListType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ListType.html#cost">cost</a></li></ul></li><li><a href="MidiType.html">MidiType</a><ul class='members'></ul></li><li><a href="ModalType.html">ModalType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ModalType.html#getPi">getPi</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getNu">getNu</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getTau">getTau</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getRho">getRho</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getOp">getOp</a></li></ul></li><li><a href="NumericType.html">NumericType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="NumericType.html#getNormalized">getNormalized</a></li></ul></li><li><a href="QLearner.html">QLearner</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="QLearner.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#getQtable">getQtable</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#doAction">doAction</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#doNext">doNext</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#doPath">doPath</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#.newQLearner">newQLearner</a></li></ul></li><li><a href="RecordType.html">RecordType</a><ul class='members'></ul></li><li><a href="ScalarField.html">ScalarField</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ScalarField.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#set">set</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#erase">erase</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#add">add</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#load">load</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#save">save</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getValues">getValues</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#has">has</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#get">get</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getExtrapolations">getExtrapolations</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getBarycenter">getBarycenter</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getDiameter">getDiameter</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getDistance">getDistance</a></li></ul></li><li><a href="SetType.html">SetType</a><ul class='members'></ul></li><li><a href="StringType.html">StringType</a><ul class='members'></ul></li><li><a href="SvgType.html">SvgType</a><ul class='members'></ul></li><li><a href="Trajectory.html">Trajectory</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Trajectory.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#addPoint">addPoint</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#addRegion">addRegion</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#add">add</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#getNext">getNext</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#isDone">isDone</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#getPath">getPath</a></li></ul></li><li><a href="Type.html">Type</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Type.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="Type.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="Type.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="Type.html#getCheckMessage">getCheckMessage</a></li><li data-type='method' style='display: none;'><a href="Type.html#getDistance">getDistance</a></li><li data-type='method' style='display: none;'><a href="Type.html#getPath">getPath</a></li><li data-type='method' style='display: none;'><a href="Type.html#compare">compare</a></li><li data-type='method' style='display: none;'><a href="Type.html#getBound">getBound</a></li><li data-type='method' style='display: none;'><a href="Type.html#getBounds">getBounds</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getType">getType</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getTypeNames">getTypeNames</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getTypeParameters">getTypeParameters</a></li><li data-type='method' style='display: none;'><a href="Type.html#.addType">addType</a></li></ul></li></ul><h3>Global</h3><ul><li><a href="global.html#json2midi">json2midi</a></li><li><a href="global.html#json2svg">json2svg</a></li><li><a href="global.html#midi2Jon">midi2Jon</a></li><li><a href="global.html#svg2json">svg2json</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">ModalType</h1>
    

    




<section>

<header>
    
        <h2>
        
            ModalType
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="ModalType"><span class="type-signature"></span>new ModalType<span class="signature">(parameters)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Specifies a level of truth, tau, between -1 (false), 0 (unknown) and 1 (true).</p>
<h4><span style='font-size: 180%; font-weight: 400; letter-spacing: -0.01em; margin: 8px 0 3px 0;'>Extends: <a href='./Type.html'>Type</a>.</span> <span style='font-size: 120%; color: #4d4e53;'>This class extends <a href='./Type.html'>Type</a>, with all public methods available.</span></h4>
<p><a name="parameters"></a></p>
<h2>Type parameters</h2>
<h3>General parameter</h3>
<ul>
<li><code>name: ...</code> The type name. By default the type name is &quot;modal&quot;.</li>
</ul>
<h3>Parameters for the semantic projection</h3>
<ul>
<li><code>trinary: ...</code> If true only the <code>false</code> (-1), <code>unknown</code> (0), and <code>true</code> (1) values are considered, without intermediate value.</li>
<li><code>binary: ...</code> If true only the <code>false</code> (-1) and <code>true</code> (1) values are considered, without intermediate value.</li>
</ul>
<h3>Parameters for the distance evaluation</h3>
<ul>
<li><code>step: ...</code> The normalization of the distance <code>|lhs-rhs|/step</code> where step is the neighborhood size.
<ul>
<li>By default 2.</li>
</ul>
</li>
</ul>
<h3>Parameters for the geodesic calculation</h3>
<ul>
<li><code>atomic: ...</code>
<ul>
<li>If true returns only an atomic path with the two left-hand and right-hand elements. Default is true.</li>
<li>If false returns a path with all intermediate values, step by step, or precision value by precision value if step is undefined.</li>
</ul>
</li>
</ul>
<p><a name="specification"></a></p>
<h2>ModalType specification</h2>
<table class="specification">
<tr style='border: 1px solid black;'><th> Syntactic projection </th><td>
- Returns <tt>NAN</tt> if not a parsable number.
<br/> - Returns the <tt>zero</tt> if an empty value.
<br/> - The value "true" (numerically <tt>1</tt>), "false" (numerically <tt>-1</tt>) and "unknown" or '?' (numerically <tt>0</tt>) are understood.
</td></tr>
<tr style='border: 1px solid black;'><th> Semantic projection  </th><td>
- If the value is higher than <tt>1</tt> it is set to <tt>true</tt>.
<br/> - If the value is lower than <tt>-1</tt> it is set to <tt>false</tt>.
<br/> - If <tt>precision</tt> is defined the value is projected to the closest <tt>min + k precision</tt> value, <tt>k</tt> being an integer.
<br/> - If in <tt>trinary</tt> mode, values are projected onto the closest <tt>{-1, 0, 1}</tt> value.
<br/> &nbsp;&nbsp;&nbsp;&nbsp; <tt>v <- v < -0.5 ? -1 : v > 0.5 ? 1 : 0</tt>
<br/> - If in <tt>binary</tt> mode, values are projected onto the closest <tt>{-1, 1}</tt> value.
<br/> &nbsp;&nbsp;&nbsp;&nbsp; <tt>v <- v <= 0 ? -1 : 1</tt>
</td></tr>
<tr style='border: 1px solid black;'><th> Distance value       </th><td>
The distance is calculated as a weighted value <tt>|lhs-rhs|/step</tt>.
<br/> - It is <tt>INFINITY</tt> if not both object are numeric.
</td></tr>
<tr style='border: 1px solid black;'><th> Geodesic path        </th><td>
The geodesic is assumed to be atomic, i.e. of length 1 if value are equal and 2 if different.
</td></tr>
<tr style='border: 1px solid black;'><th> Comparison           </th><td>
- Returns either <tt>lhs-rhs</tt> or
<br/> <tt>0</tt> if the precision is defined and <tt>|lhs-rhs| < precision</tt>.
</td></tr>
<tr style='border: 1px solid black;'><th> Bounds           </th><td>
- `[-1, 1]` are the bounds.
</td></tr>
</table>
<h2>Note:</h2>
<ul>
<li>It is implemented as a <code>NumericType({ ... min: -1 max: 1 step: 2 atomic: true})</code>.</li>
<li>This representation is in one to one correspondence with <a href="https://en.wikipedia.org/wiki/Possibility_theory">possibility and necessity modal logic</a> as implemented using <a href="#getPi"><code>getPi()</code></a>, <a href="#getNu"><code>getNu()</code></a> and <a href="#getTau"><code>getTau()</code></a>.</li>
<li>This representation is compatible with <a href="https://hal.inria.fr/hal-03886219">2D modal logic</a> as implemented using <a href="#getTau"><code>getTau()</code></a> and <a href="#getRho"><code>getRho()</code></a>.</li>
<li>Usual Boolean operations are generalized to modal value as implemented in <a href="#getOp"><code>getOp()</code></a>.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>
|

<span class="param-type">String</span>



            
            </td>

            

            

            <td class="description last"><p>The type parameters.</p></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="getPi"><span class="type-signature"></span>getPi<span class="signature">(tau)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the possibility value of a modal value.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>tau</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            

            

            <td class="description last"><p>The modal value.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The corresponding possibility value, i.e., <code>min(1, value + 1)</code></p>
</div>



    



        
            

    

    <h4 class="name" id="getNu"><span class="type-signature"></span>getNu<span class="signature">(tau)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the necessity value of a modal value.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>tau</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            

            

            <td class="description last"><p>The modal value.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The corresponding necessity value, i.e., <code>max(0, value)</code>.</p>
</div>



    



        
            

    

    <h4 class="name" id="getTau"><span class="type-signature"></span>getTau<span class="signature">(pi, nu)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the value tau corresponding to a given possibility and necessity.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>pi</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            

            

            <td class="description last"><p>The possibility value.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>nu</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            

            

            <td class="description last"><p>The necessity value.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The corresponding closest modal value, i.e., tau = nu + pi - 1 bounded in [-1, 1].</p>
</div>



    



        
            

    

    <h4 class="name" id="getRho"><span class="type-signature"></span>getRho<span class="signature">(pi, nu)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the randomness corresponding to a given possibility and necessity.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>pi</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            

            

            <td class="description last"><p>The possibility value.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>nu</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            

            

            <td class="description last"><p>The necessity value.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The corresponding closest randomness value, i.e., rho = nu - pi + 1 bounded in [0, 1].</p>
</div>



    



        
            

    

    <h4 class="name" id="getOp"><span class="type-signature"></span>getOp<span class="signature">(op, tau_1, tau_2)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the value tau corresponding to a generalized Boolean operation.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>op</code></td>
            

            <td class="type">
            
                
<span class="param-type">char</span>



            
            </td>

            

            

            <td class="description last"><p>The binary operation:</p>
<ul>
<li><code>a</code> : logical <code>and</code>, i.e., conjunction.</li>
<li><code>o</code> : logical <code>or</code>, i.e., disjunction.</li>
<li><code>x</code> : logical <code>xor</code>, i.e., exclusive disjunction.</li>
<li><code>m</code> : logical <code>minus</code>, i.e., element set difference.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>tau_1</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            

            

            <td class="description last"><p>The possibility value.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>tau_2</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            

            

            <td class="description last"><p>The possibility value.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The corresponding tau value.</p>
</div>



    



        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2024-03-05 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>